* CONSULIB.PRG
* PROGRAMA DE LIBRERIAS
* CONSULTORES EN SISTEMAS
* GUATEMALA, 7 DE JUNIO DE 1,993

#include "set.ch"
#include "inkey.ch"
#include "setcurs.ch"
#include "memoedit.ch"

/* key defs for pe */
#define EK_WRITE K_ALT_W
#define EK_QUIT  K_ESC
#define EK_WQUIT K_CTRL_W

/* structure used to contain information about edit in progress */
#define ES_TOP      1
#define ES_LEFT     2
#define ES_BOTTOM   3
#define ES_RIGHT    4

#define ES_FILE     5
#define ES_TEXT     6

#define ES_WIDTH    7
#define ES_TABSIZE  8
#define ES_SCROLL   9
#define ES_WRAP     10
#define ES_INS      11

#define ES_ROW      12
#define ES_COL      13
#define ES_RELROW   14
#define ES_RELCOL   15

#define ES_CHANGED  16
#define ES_LASTKEY  17

#define ES_PATTERN  18

#define ES_LENGTH   18


#define NextTab(y, z)   ( ( (y) + z ) - ( (y) % z ) )
/* static vars scope to entire module */
static aEdit
static nMaxRow
static nMaxCol
static nStatCol

*********************************************************************
* ENCRYX FUNCTION
*
* Encripta o Des-encripta una frase o sentencia                    
* USO                                          
*                                              
*     frase = encryx("sentencia",n)            
*                                              
* donde "n" si es 1....ENCRIPTA                
*           si es 0....DES-ENCRIPTA            
*
*            
FUNCTION encryx
PRIVATE encfra,encar,encfin
PARAMETERS encfra,encripta
IF PCOUNT()=0
   encfra=" "
ENDIF
IF PCOUNT()=1
   encripta=1
ENDIF
encfin=encfra
encont=1
DO WHILE encont<=LEN(encfra)
   encar=SUBSTR(encfra,encont,1)
   IF encripta=1
      IF encont=1
         encfin=CHR((ASC(CHR(ASC(encar)+8))-3)+7)
      ELSE
         encfin=encfin+CHR((ASC(CHR(ASC(encar)+8))-3)+7)
      ENDIF
   ELSE
      IF encont=1
         encfin=CHR((ASC(CHR(ASC(encar)-8))+3)-7)
      ELSE
         encfin=encfin+CHR((ASC(CHR(ASC(encar)-8))+3)-7)
      ENDIF
   ENDIF     
   encont=encont+1
ENDDO
RETURN encfin
* END - encryx
*********************************************************************

*********************************************************************
*  NET_USE FUNCTION
*
*  Trys to open a file for exclusive or shared use.
*  SET INDEXes in calling procedure if successful.
*  Pass the following parameters
*    1. Character - name of the .DBF file to open
*    2. Logical - mode of open (exclusive/.NOT. exclusive)
*    3. Numeric - seconds to wait (0 = wait forever)
*
*  Example:
*    IF NET_USE("Accounts", .T., 5)
*       SET INDEX TO Name
*    ELSE
*       ? "Account file not available"
*    ENDIF

FUNCTION NET_USE
PARAMETERS file, ex_use, wait
PRIVATE forever
fileals=SUBSTR(file,1,5)
fileuso=fileals+xcodemp+'.DAT'

IF SUBSTR(file,1,3) $ 'CFACINCCCCCOCIV'
    IF .NOT. FILE("&fileuso")
       RETURN (.F.)
    ENDIF
ELSE
    IF .NOT. FILE("&file")
       RETURN (.F.)
    ENDIF
ENDIF

forever = (wait = 0)
DO WHILE (forever .OR. wait > 0)

   IF ex_use                    && exclusive
      IF SUBSTR(file,1,3) $ 'CFACINCCCCCOCIV'
         USE &fileuso EXCLUSIVE && ALIAS &fileals
      ELSE
         USE &file EXCLUSIVE
      ENDIF
   ELSE   		&& shared
      IF SUBSTR(file,1,3) $ 'CFACINCCCCCOCIV'
         USE &fileuso   && ALIAS &fileals
      ELSE
         USE &file
      ENDIF
   ENDIF

   IF EMPTY(dbf())
      RETURN (.F.)
   ENDIF

   IF .NOT. NETERR()           && USE succeeds
      RETURN (.T.)
   ENDIF
   
   INKEY(1) 	          	&& wait 1 second
   wait = wait - 1
ENDDO
RETURN (.F.)			&& USE fails
* End - NET_USE
*********************************************************************

*********************************************************************
*  FIL_LOCK FUNCTION
*
*  Trys to lock the current shared file 
*  Pass the following parameter
*    1. Numeric - seconds to wait (0 = wait forever)
*
* Example:
*    IF FIL_LOCK(5)
*      REPLACE ALL Price WITH Price * 1.1
*    ELSE
*      ? "File not available"
*    ENDIF 

FUNCTION FIL_LOCK
PARAMETERS wait
PRIVATE forever

IF FLOCK()
   RETURN (.T.)		&& locked
ENDIF
      
forever = (wait = 0)
DO WHILE (forever .OR. wait > 0)

   INKEY(.5)			&& wait 1/2 second
   wait = wait - .5

   IF FLOCK()
      RETURN (.T.)		&& locked
   ENDIF
      
ENDDO
RETURN (.F.)			&& not locked
* End - FIL_LOCK
*********************************************************************

*********************************************************************
*  REC_LOCK FUNCTION
*
*  Trys to lock the current record
*  Pass the following parameter
*    1. Numeric - seconds to wait (0 = wait forever)
*
* Example:
*   IF REC_LOCK(5)
*      REPCLACE Price WITH newprice
*   ELSE
*      ? "Record not available"
*   ENDIF  

FUNCTION REC_LOCK
PARAMETERS wait
PRIVATE forever

IF RLOCK()
   RETURN (.T.)		&& locked
ENDIF

forever = (wait = 0)
DO WHILE (forever .OR. wait > 0)

   IF RLOCK()
      RETURN (.T.)		&& locked
   ENDIF
      
   INKEY(.5)			&& wait 1/2 second
   wait = wait - .5

ENDDO
RETURN (.F.)			&& not locked
* End - REC_LOCK
*********************************************************************

*********************************************************************
*   ADD_REC FUNCTION
*
*  Returns true if record appended.  The new record is current
*  and locked.
*  Pass the following parameter
*    1. Numeric - seconds to wait (0 = wait forever)
*

FUNCTION ADD_REC
PARAMETERS wait
PRIVATE forever

APPEND BLANK
IF .NOT. NETERR()
   RETURN (.T.)
ENDIF

forever = (wait = 0)
DO WHILE (forever .OR. wait > 0)

   APPEND BLANK
   IF .NOT. NETERR()
      RETURN .T.
   ENDIF
      
   INKEY(.5)			&& wait 1/2 second
   wait = wait - .5

ENDDO
RETURN (.F.)			&& not locked
* End ADD_REC
*********************************************************************

* End - LOCKS
**************************************************************************

PROCEDURE Siguiente
PARAMETERS Mensaje,Colu
IF !EOF()
   SKIP
ENDIF
IF BOF()
   SKIP
ENDIF
IF EOF()
   DO Mens WITH Mensaje,Colu
   SKIP -1
ENDIF
RETURN

* * * * * * * * * *              ANTERIOR                    * * * * * * * * *
PROCEDURE Anterior
PARAMETERS Mensaje,Colu
IF EOF()
   SKIP -1
ENDIF
IF !BOF()
   SKIP -1
ENDIF
IF BOF()
   DO Mens WITH Mensaje,Colu
ENDIF
RETURN
* * * * * * * * * * * * * * * Primero * * * * * * * * * * * * * * * * * *
PROCEDURE Primero
PARAMETERS Mensaje,Colu
GO TOP
IF EOF()
   DO Mens WITH Mensaje,Colu
ENDIF
RETURN
* * * * * * * * * * * * * * * Ultimo * * * * * * * * * * * * * * * * * *
PROCEDURE Ultimo
PARAMETERS Mensaje,Colu
GO TOP
IF EOF()
   DO Mens WITH Mensaje,Colu
ELSE
   GO BOTTOM
ENDIF
RETURN

FUNCTION Wopen
***************************
* _w1,_w2,_w3,_w4 Cordenadas
* _ w5 Color
* _ w6 Tipo de Sombra
* _w7 Explode
* _w8 Single o Double
***************************
PARAMETERS _w1,_w2,_w3,_w4,_w5,_w6,_w7,_w8,_w9

IF PCOUNT()=4
   _w5=SetColor()
   _w6=5
   _w7=0
   _w8='S'
ElseIf PCOUNT()=5
   _w6=5
   _w7=0
   _w8='S'
ElseIf PCOUNT()=6
   _w7=0
   _w8='S'
ElseIf PCOUNT()=7
   _w8='S'
ENDIF
IF _w6 = 3
   _n1=_w1
   _n2=_w2
   _n3=_w3+1
   _n4=_w4+2
ElseIf _w6 = 1
   _n1=_w1
   _n2=_w2-2
   _n3=_w3+1
   _n4=_w4
ElseIf _w6 = 7
   _n1=_w1-1
   _n2=_w2-2
   _n3=_w3
   _n4=_w4
ElseIf _w6 = 9
   _n1=_w1-1
   _n2=_w2
   _n3=_w3
   _n4=_w4+2
ELSE
   _n1=_w1
   _n2=_w2
   _n3=_w3
   _n4=_w4
ENDIF
IF PCOUNT() <= 8
   allscreens[scr_level]=SaveScreen(_n1,_n2,_n3,_n4)
   allwindows[scr_level]=TRANSFORM(_n1,"99")+"/"+;
      TRANSFORM(_n2,"99") + "/" + TRANSFORM(_n3,"99") + ;
      "/" + TRANSFORM(_n4,"99") + "/" + TRANSFORM(_w7,"99")
   Scr_level = IF (Scr_Level = 10, scr_level, scr_level+1)
ENDIF
SetColor(_w5)
IF !EMPTY(_w7)
   Blowup(_w1,_w2,_w3,_w4)
ENDIF

@ _w1,_w2,_w3,_w4 Box SPACE(9)
@ _w1,_w2,_w3,_w4 Box SUBSTR(IIF(_w8='S',scrframeS,scrframeD),1,8)
Sombra=(STR(_w6,1)) $ '1379'
IF Sombra
   IF _w6 = 3
      RestScreen(_n3,_w2+2,_n3,_n4, ;
         Dulling(SaveScreen(_n3,_w2+2,_n3,_n4)))
      RestScreen(_w1+1,_n4-1,_n3,_n4, ;
         Dulling(SaveScreen(_w1+1,_n4-1,_n3,_n4)))
      ElseIf _w6 = 1
      RestScreen(_n3,_n2,_n3,_w4-1,;
         Dulling(SaveScreen(_n3,_n2,_n3,_w4-1)))
      RestScreen(_n1+1,_n2,_w3+1,_n2+1,;
         Dulling(SaveScreen(_n1+1,_n2,_w3+1,_n2+1)))
      ElseIf _w6 = 7
      RestScreen(_n1,_n2,_n1,_w4-2,;
         Dulling(SaveScreen(_n1,_n2,_n1,_w4-2)))
      RestScreen(_n1,_n2,_n3-1,_n2+1,;
         Dulling(SaveScreen(_n1,_n2,_n3-1,_n2+1)))
      ElseIf _w6 = 9
      RestScreen(_n1,_w2+2,_n1,_n4,;
         Dulling(SaveScreen(_n1,_w2+2,_n1,_n4)))
      RestScreen(_n1,_n4-1,_n3-1,_n4,;
         Dulling(SaveScreen(_n1,_n4-1,_n3-1,_n4)))
   ENDIF
ENDIF
*IF PCOUNT()<=8
*   Suena(500,8,8,500)
*ENDIF
RETURN (scr_level)

FUNCTION Wclose

PARAMETERS _w1,_w2,_w3,_w4
*Suena(750,8,8,750)
IF PCOUNT()=4
   _wcol = Setcolor()
ElseIf PCOUNT()=0 .Or. PCOUNT()=1
   IF PCOUNT()=1
      scr_level=_w1+1
   ENDIF
   _w1 = VAL(SUBSTR(allwindows[Scr_Level - 1], 1,  2))
   _w2 = VAL(SUBSTR(allwindows[Scr_Level - 1], 4,  2))
   _w3 = VAL(SUBSTR(allwindows[Scr_Level - 1], 7,  2))
   _w4 = VAL(SUBSTR(allwindows[Scr_Level - 1], 10, 2))
   _w5 = VAL(SUBSTR(allwindows[Scr_Level - 1], 13, 2))
ENDIF

IF PCOUNT() != 1
   scr_level = IF (scr_level = 1,scr_level,scr_level-1)
ENDIF
RestScreen(_w1,_w2,_w3,_w4, allscreens[scr_level])

allscreens[scr_level] = ""
allwindows[scr_level] = ""
RETURN (.t.)

FUNCTION Dulling

PARAMETERS _astring

IF TYPE("_astring") != "C"
   RETURN ("")
ENDIF
PRIVATE _qqq, _gstring

_gstring = ""
Culur=IIF(ISCOLOR(),'SUBSTR(_astring, _qqq, 1)','Chr(177)')
Attrib=IIF(ISCOLOR(),'Chr(8)','Chr(15)')
FOR _qqq = 1 TO LEN(_astring) STEP 2
   _gstring = _gstring + &Culur + &Attrib
NEXT

RETURN (_gstring)

FUNCTION Blowup

PARAMETERS _blow1, _blow2, _blow3, _blow4

IF EMPTY(PCOUNT())
   RETURN (.f.)
   ElseIf TYPE("_blow1") + TYPE("_blow2") + ;
      TYPE("_blow3") + TYPE("_blow4") != "NNNN"
   RETURN (.F.)
ENDIF

_seed1  = INT((_blow3 - _blow1) / 2)
_seed2  = INT((_blow4 - _blow2) / 2)
_blowt1 = _blow1 + _seed1
_blowt2 = _blow2 + _seed2
_blowt3 = _blowt1
_blowt4 = _blowt2

DO WHILE (_blowt1 > _blow1 .And. _blowt2 > _blow2 ) ;
   .And. (_blowt3 < _blow3 .And. _blowt4 < _blow4)
   @ _blowt1, _blowt2, _blowt3, _blowt4 ;
      BOX SUBSTR(scrframeS, 1, 8)
   SCROLL(_blowt1,_blowt2,_blowt3,_blowt4,0)
   _blowt1 = _blowt1 - 1
   _blowt2 = _blowt2 - ( _seed2 / _seed1 )
   _blowt3 = _blowt3 + 1
   _blowt4 = _blowt4 + (_seed2 / _seed1)
ENDDO
RETURN (.T.)
******************************************************************************
* Funcion que centra strings para desplegarlos en pantalla.                  *
******************************************************************************
FUNCTION center
PARAMETERS string
RETURN INT((80-LEN(string))/2)

******************************************************************************
* Procediento que despliega mensajes en la linea de comandos                 *
******************************************************************************
PROCEDURE Mens
PARAMETER line_,coor
Suena(3000,20,10,1000)
NEW_COLOR=Error
CURR_COLOR=SETCOLOR(NEW_COLOR)
@ coor,Center(Line_) SAY Line_
INKEY(0)
SETCOLOR(CURR_COLOR)
@ Coor,0

RETURN

FUNCTION CENTERING
PARAMETERS STRING,KK_
IF TYPE("KK_") <> "N"
   KK_= 80
ENDIF
STORE (KK_- LEN(STRING))/2 TO TEMP
IF 2*TEMP+LEN(STRING)<KK_
   RETURN (SPACE(TEMP)+STRING+ SPACE(TEMP)+'  ')
ENDIF
RETURN (SPACE(TEMP)+STRING+SPACE(TEMP))

FUNCTION FECHA
PARAMETERS FEC
T=' '
M=MONTH(FEC)
DO CASE
CASE M = 1
   STORE "Enero" TO ME
CASE M = 2
   STORE "Febrero" TO ME
CASE M = 3
   STORE "Marzo" TO ME
CASE M = 4
   STORE "Abril" TO ME
CASE M = 5
   STORE "Mayo" TO ME
CASE M = 6
   STORE "Junio" TO ME
CASE M = 7
   STORE "Julio" TO ME
CASE M = 8
   STORE "Agosto" TO ME
CASE M = 9
   STORE "Septiembre" TO ME
CASE M = 10
   STORE "Octubre" TO ME
CASE M = 11
   STORE "Noviembre" TO ME
CASE M = 12
   STORE "Diciembre" TO ME
otherwise
   Store "" to ME
ENDCASE

DI=DOW(FEC)
DO CASE
CASE DI = 1
   STORE "Domingo " TO DIA
CASE DI = 2
   STORE "Lunes " TO DIA
CASE DI = 3
   STORE "Martes " TO DIA
CASE DI = 4
   STORE "Miercoles " TO DIA
CASE DI = 5
   STORE "Jueves " TO DIA
CASE DI = 6
   STORE "Viernes " TO DIA
CASE DI = 7
   STORE "Sabado " TO DIA
otherwise
   Store "Sin Fecha" to DIA
ENDCASE
RETURN (STR(DAY(FEC),2,0)+" de "+ME+"'"+SUBSTR(STR(YEAR(FEC),4),1,4))

FUNCTION FECHA_REP
PARAMETERS FEC
T=' '
M=MONTH(FEC)
DO CASE
CASE M = 1
   STORE "Enero" TO ME
CASE M = 2
   STORE "Febrero" TO ME
CASE M = 3
   STORE "Marzo" TO ME
CASE M = 4
   STORE "Abril" TO ME
CASE M = 5
   STORE "Mayo" TO ME
CASE M = 6
   STORE "Junio" TO ME
CASE M = 7
   STORE "Julio" TO ME
CASE M = 8
   STORE "Agosto" TO ME
CASE M = 9
   STORE "Septiembre" TO ME
CASE M = 10
   STORE "Octubre" TO ME
CASE M = 11
   STORE "Noviembre" TO ME
CASE M = 12
   STORE "Diciembre" TO ME
otherwise
   Store "" to ME
ENDCASE

DI=DOW(FEC)
DO CASE
CASE DI = 1
   STORE "Domingo " TO DIA
CASE DI = 2
   STORE "Lunes " TO DIA
CASE DI = 3
   STORE "Martes " TO DIA
CASE DI = 4
   STORE "Miercoles " TO DIA
CASE DI = 5
   STORE "Jueves " TO DIA
CASE DI = 6
   STORE "Viernes " TO DIA
CASE DI = 7
   STORE "Sabado " TO DIA
otherwise
   Store "Sin Fecha" to DIA
ENDCASE
RETURN "AL " + (STR(DAY(FEC),2,0)+" DE "+UPPER(ME)+" "+SUBSTR(STR(YEAR(FEC),4),1,5))

FUNCTION MES_O
PARAMETERS FEC
T=' '
M=MONTH(FEC)
DO CASE
CASE M = 1
   STORE "Enero" TO ME
CASE M = 2
   STORE "Febrero" TO ME
CASE M = 3
   STORE "Marzo" TO ME
CASE M = 4
   STORE "Abril" TO ME
CASE M = 5
   STORE "Mayo" TO ME
CASE M = 6
   STORE "Junio" TO ME
CASE M = 7
   STORE "Julio" TO ME
CASE M = 8
   STORE "Agosto" TO ME
CASE M = 9
   STORE "Septiembre" TO ME
CASE M = 10
   STORE "Octubre" TO ME
CASE M = 11
   STORE "Noviembre" TO ME
CASE M = 12
   STORE "Diciembre" TO ME
otherwise
   Store "" to ME
ENDCASE
RETURN ME

FUNCTION DATEREP
PARAMETERS FEC
T=' '
M=MONTH(FEC)
DO CASE
CASE M = 1
   STORE "Enero" TO ME
CASE M = 2
   STORE "Febrero" TO ME
CASE M = 3
   STORE "Marzo" TO ME
CASE M = 4
   STORE "Abril" TO ME
CASE M = 5
   STORE "Mayo" TO ME
CASE M = 6
   STORE "Junio" TO ME
CASE M = 7
   STORE "Julio" TO ME
CASE M = 8
   STORE "Agosto" TO ME
CASE M = 9
   STORE "Septiembre" TO ME
CASE M = 10
   STORE "Octubre" TO ME
CASE M = 11
   STORE "Noviembre" TO ME
CASE M = 12
   STORE "Diciembre" TO ME
otherwise
   Store "" to ME
ENDCASE
RETURN " "+(STR(DAY(FEC),2,0)+"/"+ME+"/"+SUBSTR(STR(YEAR(FEC),4),1,4))

FUNCTION FECHA2
PARAMETERS FEC
STORE ' ' TO T
STORE MONTH(FEC) TO M
DO CASE
CASE M = 1
   STORE "enero" TO ME
CASE M = 2
   STORE "febrero" TO ME
CASE M = 3
   STORE "marzo" TO ME
CASE M = 4
   STORE "abril" TO ME
CASE M = 5
   STORE "mayo" TO ME
CASE M = 6
   STORE "junio" TO ME
CASE M = 7
   STORE "julio" TO ME
CASE M = 8
   STORE "agosto" TO ME
CASE M = 9
   STORE "septiembre" TO ME
CASE M = 10
   STORE "octubre" TO ME
CASE M = 11
   STORE "noviembre" TO ME
CASE M = 12
   STORE "diciembre" TO ME
otherwise
   store '' to Me
ENDCASE

RETURN STR(DAY(FEC),2)+" de "+Me+" de "+STR(YEAR(FEC),4)

FUNCTION Confirmado
Wopen(11,17,16,61,Ventana,0,1,'S')
@ 11,17 SAY "Ŀ"
@ 12,17 SAY "                                           "
@ 13,17 SAY "                                           "
@ 14,17 SAY "͵"
@ 15,17 SAY "                                          "
@ 16,17 SAY ""
SetColor(Datos)
@ 12,26  SAY "Confirme la impresin del"
@ 13,35  SAY "Reporte"
SetColor(Menu)
@ 15,24 Prompt 'Imprime'
@ 15,47 Prompt 'Cancela'
Menu to VarCho
Wclose()
RETURN IIF(VarCho=1,.T.,.F.)

FUNCTION DISPOSITIVO
* PREGUNTA EL DISPOSITIVO DE SALIDA
Wopen(12,18,14,64,VENTANA,3,1,'D')
@ 13,20 PROMPT "Impresora"    && Pantalla   Finaliza"
@ 13,32 PROMPT "Pantalla "
@ 13,44 PROMPT "Visual "
@ 13,53 PROMPT "Finaliza "
MENU TO opdisp
Wclose()

IF opdisp = 1
   RETURN "I"
ELSEIF opdisp = 2
   RETURN "P"
ELSEIF opdisp = 3
   RETURN "V"
ELSEIF opdisp = 4
   RETURN "F"
ELSE
   RETURN "F"
ENDIF

FUNCTION Encontro
PARAMETERS Sel,Ord,KEY
Sele_Ant=SELECT()
Order_Ant=IndexOrd()
SELECT(Sel)
SET ORDER TO Ord
SEEK KEY
F=FOUND()
SELECT(Sele_Ant)
SET ORDER TO Order_Ant
RETURN F

PROCEDURE BNomApel
PARAMETERS Xn,Yn,Xa,Ya,SpaceN,SpaceA,Orden_,Coor
SetColor(Ingreso)
Nom=SPACE(SpaceN)
ape=SPACE(SpaceA)
SET ORDER TO Orden_
DO WHILE .T.
   @ Xn,Yn GET Nom PICTURE "@!"
   @ Xa,Ya GET Ape PICT "@!"
   READ
   IF LastKey()=27 .Or. EMPTY(Ape)
      GO TOP
      RETURN
   ENDIF
   SEEK TRIM(Ape)
   IF !FOUND()
      DO Mens WITH "Nombre no Existente, <Enter> para Continuar",Coor
   ELSE
      Nom=IIF(EMPTY(Nom),SPACE(1),TRIM(Nom))
      IF AT(Nom,usuario)=0
         DO WHILE .T.
            SKIP
            IF AT(TRIM(Ape),Apellido) = 0 .Or. AT(Nom,usuario) > 0
               EXIT
            ENDIF
         ENDDO
      ENDIF
      EXIT
   ENDIF
ENDDO
IF AT(TRIM(Ape),Apellido) = 0
   DO Mens WITH "Nombre no Existente, <Enter> para Continuar",Coor
ENDIF
RETURN

FUNCTION Existe
PARAMETERS ramin,Select_,Order_,Nomb,Existe_,Regreso,Campito,_Trim,Busqueda
SAVE SCREE
IF ramin='CONSULTOR'    && Supervisor
   Mensaje=" ya Existente, [ENTER] para continuar"
   RETURN .T.
ENDIF

IF PCOUNT() <= 8
   _Trim=.f.
   Busqueda=0
ENDIF
IF EMPTY(ramin)
   RESTORE SCREEN
   RETURN Regreso
ENDIF
Mensaje=IIF(Existe_," inexistente, [ENTER] para continuar"," ya Existente, [ENTER] para continuar")

Condicion=IIF(Existe_,"!Found()","Found()")
Sele_Ant=SELECT()
SELECT(Select_)
SELECT USUARIOS
SET ORDER TO 1 && Order_
IF _Trim
   SEEK z_sistema+TRIM(ramin)
ELSE
   SEEK z_sistema+ramin
ENDIF
IF &Condicion
   Mens(Nomb+Mensaje,Coordenada)
   SetColor(Ventana)
   @ 19,0 SAY ""
   xacepte=.F.
   IF Existe_ .AND. xacepte
      GO TOP
      _Curr=SetColor()
      SET ORDER TO IIF(!EMPTY(Busqueda),Busqueda,Order_)
      BROW (8,9,20,70,.t.,.t.,'','',0,'')
      SET ORDER TO Order_
      SetColor(_Curr)
      Ramin=&Campito
   ENDIF
   SELECT(Sele_Ant)
   RESTORE SCREEN
   RETURN .f.
ELSE
   SELECT(Sele_Ant)
   RESTORE SCREEN
   RETURN .t.
ENDIF

**************************************************************************
* Funcion para editar varios campos
**************************************************************************
FUNCTION BROW
PARAMETERS X1,Y1,X2,Y2,Vector1,Vector2,Llave,Tabla,Area,Ord
IF !EMPTY(LLave) .And. !EMPTY(Tabla)
   CurrSel=SELECT()
   SELECT(Area)
   SET ORDER TO &Ord
   SELECT(CurrSel)
   SET RELATION TO &Llave INTO &Tabla
ENDIF
culur=IIF(ISCOLOR(),'+w/bg','w,i')
Wopen(X1-1,Y1-1,X2+1,Y2+1,Culur,1,1,'S')
IF ISCOLOR()
   SET COLOR TO B/BG,+Gr/b
ENDIF
La_Func=IIF(TYPE("Vector1")="L",'Que_tecla',.t.)
KEY =''
DbEdit(X1,Y1,X2-1,Y2,Vector1,La_Func,.t.,Vector2)
Wclose()
IF !EMPTY(LLave) .And. !EMPTY(Tabla)
   SET RELATION TO
ENDIF
RETURN .t.
****************************************************************
FUNCTION Que_tecla
PARAMETERS Modo
IF Modo=0
   RETURN (1)
ENDIF
Tecla=LastKey()
IF ( Tecla=27 .Or. Tecla=13 ) .And. Modo=4
   RETURN (0)
ElseIf Tecla=-3 .And. Select()=7  && Browse de Ramos
       REC_LOCK(0)
       Replace X with IIF(Empty(X),Chr(16),' ')
       Skip 0
       Unlock
ElseIf (Tecla>=97 .And. Tecla<=122) .Or. Tecla=32 .Or. (Tecla>=65 .And. Tecla<=90);
      .Or. (Tecla>=48 .And. Tecla<=57) .Or. Tecla=45 && Entre a y z , A y Z
   Suena(900,8,8,900)
   Curr_Col=SetColor(MENU )
   KEY =KEY +CHR(Tecla)
   @ 20,11 SAY 'Buscando : '+SPACE(40)
   @ 20,11 SAY 'Buscando : '+KEY
   SetColor(Curr_Col)
   IF !EMPTY(Busqueda)
      ultimo_ord=IndexOrd()
      SET ORDER TO Busqueda
   ENDIF
   Wher=RECNO()
   SEEK TRIM(KEY )
   IF !FOUND()
      Tone(675,1)
      GO Wher
   ENDIF
   IF !EMPTY(Busqueda)
      SET ORDER TO ultimo_ord
   ENDIF
   ElseIf Tecla=8
   Suena(200,8,8,200)
   KEY =IIF(LEN(KEY )=0,'',SUBSTR(KEY ,1,LEN(KEY )-1))
   Curr_Col=SetColor(MENU )
   @ 20,11 SAY 'Buscando : '+SPACE(40)
   @ 20,11 SAY 'Buscando : '+KEY
   SetColor(Curr_Col)
   IF !EMPTY(Busqueda)
      ultimo_ord=IndexOrd()
      SET ORDER TO Busqueda
   ENDIF
   Wher=RECNO()
   SEEK TRIM(KEY )
   IF !FOUND()
      Tone(675,1)
      GO Wher
   ENDIF
   IF !EMPTY(Busqueda)
      SET ORDER TO ultimo_ord
   ENDIF
ENDIF
RETURN (1)

FUNCTION Respuesta
PARAMETERS Opciones,Linea,Message
*@ Linea,0
DECI =" "
SetColor(Ingreso)
DO WHILE ! DECI $ Opciones
*  Suena(300,8,8,300)
   Deci=Pida(Message,1)
   Deci=Upper(Deci)
*  @ Linea,Center(Message) SAY Message GET DECI PICT "!"
*  READ
ENDDO
*Suena(200,2,10,2000)
*@ Linea,0
RETURN DECI

FUNCTION Pida
PARAMETERS Titulo_,Long,Vallin
Arin=IIF(PCOUNT()=2,SPACE(Long),&Vallin)
Lago=LEN(Titulo_)+3+Long
Xz=INT((80-Lago)/2)
Wopen(11,Xz-1,13,Xz+Lago,Ventana,1,1,'S')
Suena(300,8,8,300)
SetColor(Datos)
@ 12,Xz SAY Titulo_
SetColor(Men2)
If Long=1
   @ 12,Xz+Len(Titulo_)+1 GET Arin PICT "@!"
Else
   @ 12,Xz+Len(Titulo_)+1 GET Arin
EndIf
READ
Wclose()
RETURN Arin
FUNCTION Choice
PARAMETERS Vector,Titulo_,Par3
Abajo=Chr(24)+','+Chr(25)+','+Chr(17)+Chr(217)+',Esc'
Max=LEN(Vector[1])
Elementos=LEN(Vector)
FOR i=2 TO Elementos
   Max=IIF(Max<LEN(Vector[i]),LEN(Vector[i]),Max)
NEXT
Y=IIF(Elementos>=18,3,INT((24-Elementos)/2))
Xp=INT((80-Max)/2)
Sume=IIF(Elementos>=18,18,Elementos)
Wopen(Y,Xp,Y+Sume+1,Xp+Max+1,Ventana2,1,1,'S')
SetColor(Otro1)
@ Y,Xp+INT((Max-LEN(Titulo_))/2)+1 SAY Titulo_
SetColor(Datos)
@ Y+Sume+1,Xp+INT((Max-10)/2)+1 SAY Abajo
SetColor(Ingreso)
IF PCOUNT()=2
   Aux1=Achoice(Y+1,Xp+1,Y+Sume,Xp+Max,Vector)
ELSE
   Aux1=Achoice(Y+1,Xp+1,Y+Sume,Xp+Max,Vector,.t.,.t.,Par3)
ENDIF
Wclose()
RETURN Aux1

FUNCTION Suena
Param U,D,T,C
if .t.
   *Sound(U,D,T,C)
   TONE(U,D,T,C)
endif

FUNCTION Chequeo
  Regreso=.t.
  New_Color=Error
  Curr_Color=SetColor(New_Color)
  Do While !IsPrinter()
     Suena(100,14,14,400)
     Wopen(19,3,22,76,Error,5,5)
     SetColor(IIf(Color,'*N/R','*I'))
     @ 20,18 SAY "Revise la impresora, porque no esta lista"
     @ 21,12 SAY "Presione <Esc> para cancelar y <Enter> para continuar"
     Inkey(0)
     If LastKey()=27
        Regreso=.f.
        Wclose()
        Exit
     EndIf
     Wclose()
  ENDDO
  SetColor(Curr_Color)
  SetPrc(0,0)
Return Regreso

FUNCTION Bold
Parameters Str_
Return Chr(27)+Chr(69)+Str_+Chr(27)+Chr(70)

Procedure Centro
Parameters Str_,Fila_
@ Fila_,Center(Str_) Say Str_
Return

FUNCTION Rango_Fechas
          Pan=SaveScreen(6,20,13,49)
          de=date()
          hasta=date()
          Wopen(8,22,12,49,Otro1,1,1,'S')
          @ 6,26 clear to 8,46
          @ 6,26 to 8,46
          SetColor(Barra)
          @ 7,28 say "Rango del Reporte"
          SetColor(Men2)
          @ 9,27 say "De:" get de
          @ 11,24 say "Hasta:" get hasta
          read
          Wclose()
          RestScreen(6,20,13,49,Pan)
Return Dtoc(De)+Dtoc(Hasta)

FUNCTION CONTROL()
fcomenta=DTOC(DATE())+TIME()+xuser
RETURN fcomenta

FUNCTION PRIVILEGIO
PARAMETERS xmenu,xopcion
IF Manager .OR. zseguridad='0'
   x_derecho=.T.
   RETURN .T.
ENDIF
***************************************
*  -  ARCHIVO DE USUARIOS   CCO08  -  *
***************************************
* INDICE                      ARCHIVO *
* ---------                   ------- *
* CODIGO_U                  - CCO081  *
***************************************
SELECT 0
NET_USE('CCO08&xcodemp..DAT',.F.,5)
USE CCO08&xcodemp..DAT
IF ! File('CCO081&xcodemp..ntx')
   INDEX ON sistema+codigo_u TO CCO081&xcodemp
ENDIF
SET INDEX TO CCO081&xcodemp
SEEK z_sistema+xuser
xtoma=.F.
IF FOUND()
   IF xmenu = 1
      *********************************************
      *    BUSCA DIRECCION DEL STRING MENU1       *
      guarda1 = xopcion * 3
      guarda2 = guarda1 - 2
      *********************************************
      xtoma  = SUBSTR(menu1,guarda2+2,1)
   ELSEIF xmenu = 2
      *********************************************
      **** BUSCA DIRECCION DEL STRING MENU2      *
      guarda1 = xopcion * 3
      guarda2 = guarda1 - 2
      *********************************************
      xtoma  = SUBSTR(menu2,guarda2+2,1)
   ELSEIF xmenu = 3
      *********************************************
      **** BUSCA DIRECCION DEL STRING MENU3      *
      guarda1 = xopcion * 3
      guarda2 = guarda1 - 2
      *********************************************
      xtoma  = SUBSTR(menu3,guarda2+2,1)
   ELSEIF xmenu = 4
      *********************************************
      **** BUSCA DIRECCION DEL STRING MENU4      *
      guarda1 = xopcion * 3
      guarda2 = guarda1 - 2
      *********************************************
      xtoma  = SUBSTR(menu4,guarda2+2,1)
   ELSEIF xmenu = 5
      *********************************************
      **** BUSCA DIRECCION DEL STRING MENU5      *
      guarda1 = xopcion * 3
      guarda2 = guarda1 - 2
      *********************************************
      xtoma  = SUBSTR(menu5,guarda2+2,1)
   ENDIF
   IF xtoma='1' 
      xtoma=.T.
   ELSE
      xtoma=.F.
   ENDIF
ENDIF
CLOSE DATA
IF ! xtoma
   x_derecho=.F.
   SETCOLOR(men2)
   TONE(100,20)
   @ 24,0 SAY CENTERING('NO TIENE DERECHOS PARA ESTA OPCION ...')
   INKEY(50)
   RETURN .F.
ELSE
   x_derecho=.T.
   RETURN .T.
ENDIF

* CONVERSION DE NUMEROS A LETRAS
FUNCTION LETTER
PARAMETERS numero
PRIVATE grupos[5],enletra, grupo,numstr,unidad,decena,centena,;
        uni0,uni1,uni2,uni3,uni4,uni5,uni6,uni7,uni8,uni9,;
        dec0,dec1,dec2,dec3,dec4,dec5,dec6,dec7,dec8,dec9,;
        cen0,cen1,cen2,cen3,cen4,cen5,cen6,cen7,cen8,cen9,;
        dec11,dec12,dec13,dec14,dec15,dec16,dec17,dec18,dec19,;
        conect1,conect2,conect3,conect4,conect5,unilet,declet,;
        cenlet,conector,grupostr

uni0     = "IIF(numero = 0 .AND. grupo = 1, 'CERO','')"
uni1     = "IIF(decena = '1',dec1&unidad,IIF(grupos[grupo]='001' .AND. (grupo = 2 .OR. grupo = 4),'', IIF(grupo>2,'UN','UNO')))"
uni2     = "IIF(decena = '1',dec1&unidad,'DOS')"
uni3     = "IIF(decena = '1',dec1&unidad,'TRES')"
uni4     = "IIF(decena = '1',dec1&unidad,'CUATRO')"
uni5     = "IIF(decena = '1',dec1&unidad,'CINCO')"
uni6     = "IIF(decena = '1',dec1&unidad,'SEIS')"
uni7     = "IIF(decena = '1',dec1&unidad,'SIETE')"
uni8     = "IIF(decena = '1',dec1&unidad,'OCHO')"
uni9     = "IIF(decena = '1',dec1&unidad,'NUEVE')"
dec0     = "''"
dec1     = "IIF(unidad = '0','DIEZ','')"
dec11    = 'ONCE'
dec12    = 'DOCE'
dec13    = 'TRECE'
dec14    = 'CATORCE'
dec15    = 'QUINCE'
dec16    = 'DIECISEIS'
dec17    = 'DIECISIETE'
dec18    = 'DIECIOCHO'
dec19    = 'DIECINUEVE'
*dec2    = "IIF(unidad = '0','VEINTE','VEINTI')"
dec2     = "IIF(unidad = '0','VEINTE','VEINTE Y ')"
dec3     = "'TREINTA' + IIF(unidad <>'0',' Y ','')"
dec4     = "'CUARENTA' + IIF(unidad <>'0',' Y ','')"
dec5     = "'CINCUENTA ' + IIF(unidad <>'0',' Y ','')"
dec6     = "'SESENTA' + IIF(unidad <>'0',' Y ','')"
dec7     = "'SETENTA' + IIF(unidad <>'0',' Y ','')"
dec8     = "'OCHENTA' + IIF(unidad <>'0',' Y ','')"
dec9     = "'NOVENTA' + IIF(unidad <>'0',' Y ','')"
cen0     = "''"
cen1     = "IIF(decena+unidad = '00','CIEN','CIENTO')"
cen2     = "'DOSCIENTOS'"
cen3     = "'TRESCIENTOS'"
cen4     = "'CUATROCIENTOS'"
cen5     = "'QUINIENTOS'"
cen6     = "'SEISCIENTOS'"
cen7     = "'SETECIENTOS'"
cen8     = "'OCHOCIENTOS'"
cen9     = "'NOVECIENTOS'"
conect1  = "''"
conect2  = "IIF(grupos[2]>'000','MIL','')"
conect3  = "IIF(grupos[3]>'000' .OR. grupos[4]>'000', IIF(grupos[3] = '001','MILLON','MILLONES'),'')"
conect4  = "IIF(grupos[4]>'000','MIL','')"
conect5  = "IIF(grupos[5]>'000',IIF(grupos[5]>'001','BILLON','BILLONES'),'')"
enletra  = ''
numstr   = ALLTRIM(STR(numero))

* CONVERSION A CARACTERES DEL NUMERO JUSTIFICANDO CON 0 A LA IZQUIERDA
numstr   = REPLICATE('0',15-LEN(numstr))+numstr

FOR grupo = 5 TO 1 STEP -1
    grupos[5-grupo+1] = SUBSTR(numstr,(grupo-1)*3+1,3)
NEXT

* PROCESO
FOR grupo = 5 TO 1 STEP -1
  unidad   = RIGHT(grupos[grupo],1)
  decena   = SUBSTR(grupos[grupo],2,1)
  centena  = LEFT(grupos[grupo],1)
  unilet   = uni&unidad
  declet   = dec&decena
  cenlet   = cen&centena
  grupostr = STR(grupo,1)
  conector = conect&grupostr
  enletra  = enletra+SPACE(1)+&cenlet+SPACE(1)+&declet+SPACE(1)+&unilet+SPACE(1)+&conector
NEXT
RETURN ALLTRIM(enletra)

****
*   pe()
*

func pe(cFile)
local nKey, lDone, cScreen
    * VERIFICA SI SE GENERO ALGUN ARCHIVO DE TEXTO (PARA PANTALLA)
    PRIV ARname[1]
    PRIV ARsize[1]
    ADIR(Files[1],ARname,ARsize)
    IF ARsize[1] = 0
       TONE(400,3)
       TONE(700,3)
       setcolor(barra)
       @ 24,0 SAY CENTERING('No Existe Informacion que genere este Reporte')
       INKEY(10)
       setcolor(men2)
       RETURN .F.
    ENDIF
    Set(_SET_BELL, .f.)
    Set(_SET_SCOREBOARD, .f.)
    SetKey(K_F1, NIL)

    SetColor(ventana)
    if ( Empty(cFile) )
        cFile := "untitled"
    elseif ( Rat(".", cFile) <= Rat("\", cFile) )
        cFile := cFile + ".&z_exten"
    end

    nMaxRow := Maxrow()
    nMaxCol := Maxcol()
    nStatCol := nMaxCol - 19

    /* create the edit structure */
    aEdit               := Array(ES_LENGTH)
    aEdit[ES_FILE]      := Lower(cFile)
    aEdit[ES_TEXT]      := MemoRead(cFile)

    aEdit[ES_TOP]       := 2
    aEdit[ES_LEFT]      := 1
    *aEdit[ES_BOTTOM]    := nMaxRow - 2
    aEdit[ES_BOTTOM]    := nMaxRow - 3
    aEdit[ES_RIGHT]     := nMaxCol

    aEdit[ES_WIDTH]     := 240
    aEdit[ES_TABSIZE]   := 132
    aEdit[ES_SCROLL]    := .f.
    aEdit[ES_WRAP]      := .t.
    aEdit[ES_INS]       := Set(_SET_INSERT)

    aEdit[ES_ROW]       := 1
    aEdit[ES_COL]       := 0
    aEdit[ES_RELROW]    := 0
    aEdit[ES_RELCOL]    := 0

    aEdit[ES_CHANGED]   := .T.
    aEdit[ES_LASTKEY]   := 0

    aEdit[ES_PATTERN]   := ""

    cScreen := SaveScreen(0, 0, nMaxRow, nMaxCol)
    cls

    @ nMaxRow - 2, 0 TO nMaxRow - 1, nMaxCol
    lDone := .f.


    while (!lDone)
        Set Key K_F7 To File_Print(cfile)
        DoEditing(cfile)

        nKey := aEdit[ES_LASTKEY]

        do case

        case (nKey == EK_QUIT)
            Set Key K_F7 To
            lDone := PExit()
            l_mas := .F.
        case (nKey == -5 )     && [F6] PANTALLA ADELANTE
           lDone := .T.
           IF indice < nfile
              indice ++
           ENDIF
           l_mas := .T.
        case (nKey == -15 )    && SHIFT + [F6] PANTALLA ATRAS
           IF indice > 1
              indice --
           ENDIF
           lDone := .T.
           l_mas := .T.
        otherwise
        end

    end

    if ( IsColor() )
        SetColor(",,n")
    end

    RestScreen(0, 0, nMaxRow, nMaxCol, cScreen)
    @ nMaxRow, nMaxCol SAY ""
return l_mas

****
*   DoEditing()
*

func DoEditing()
PARAMETERS cFile

    aEdit[ES_WRAP] := .t.
    aEdit[ES_TEXT] := MemoEdit( aEdit[ES_TEXT],     ;
                                aEdit[ES_TOP],      ;
                                aEdit[ES_LEFT],     ;
                                aEdit[ES_BOTTOM],   ;
                                aEdit[ES_RIGHT],    ;
                                .F., "ufunc",       ;
                                aEdit[ES_WIDTH],    ;
                                aEdit[ES_TABSIZE],  ;
                                aEdit[ES_ROW],      ;
                                aEdit[ES_COL],      ;
                                aEdit[ES_RELROW],   ;
                                aEdit[ES_RELCOL]    ;
                              )

return (NIL)

* IMPRIME ARCHIVO QUE SE DESPLIEGA POR PANTALLA
FUNCTION File_Print
PRIVATE buffer
Set Key K_F7 To
SETCOLOR(ventana)
SAVE SCREEN TO printpan
SET DEVICE TO PRINT
SET CONSOLE OFF
SET PRINT ON
buffer = MEMOREAD(cfile)
DO WHILE ! isprinter()
   SET DEVICE TO SCREEN
   SETColor(error)
   Suena(100,14,14,400)
   Wopen(19,3,22,76,Error,5,5)
   SetColor(IIf(Color,'*N/R','*I'))
   @ 20,18 SAY "Revise la impresora, porque no esta lista"
   @ 21,12 SAY "Presione [Esc] para cancelar y [ENTER] para continuar"
   INKEY(0)
   IF LASTKEY()=27
      Set Key K_F7 To File_Print(cfile)
      SETCOLOR(ventana)
      RESTORE SCREEN FROM printpan
      RETURN 0
      WCLOSE()
      EXIT
   ENDIF
   WCLOSE()
   SET DEVICE TO PRINT
ENDDO
SetPrc(0,0)
SET DEVICE TO SCREEN
setcolor(Men2)
@ 24,0 SAY CENTERING('Generando Reporte...')
SET DEVICE TO PRINT
SET PRINT ON
?? buffer
SET DEVICE TO SCREEN
SET CURSOR ON
SET CONSOLE ON
SET PRINT OFF
SETCOLOR(ventana)
RESTORE SCREEN FROM printpan
Set Key K_F7 To File_Print(cfile)
SETCOLOR(ventana)
RETURN 0

****
*   Prompt()
*

func Prompt(cSay, cGet)
local getList := {}, bInsSave, bAltISave

    bInsSave := SetKey(K_INS, {|| SetCursor(if( Set(_SET_INSERT,            ;
                                                !Set(_SET_INSERT) ),        ;
                                                SC_NORMAL, SC_INSERT) ) }   ;
                      )

    bAltISave := SetKey(K_ALT_I, SetKey(K_INS))

    Msg(Space(nStatCol))
    @ nMaxRow,0 SAY cSay
    @ nMaxRow,0 SAY "                   " GET cGet    ;
                Picture "@KS" + Ltrim(Str(nStatCol - (Len(cSay) + 2)))
    READ

    SetKey(K_INS, bInsSave)
    SetKey(K_ALT_I, bAltISave)
    aEdit[ES_INS] := Set(_SET_INSERT)

return (cGet)

****
*   ufunc()
*

FUNCTION ufunc(nMode, nLine, nCol)
local nKey

    aEdit[ES_LASTKEY]   := nKey := LastKey()
    aEdit[ES_ROW]       := nLine
    aEdit[ES_COL]       := nCol
    aEdit[ES_RELROW]    := Row() - aEdit[ES_TOP]
    aEdit[ES_RELCOL]    := Col() - aEdit[ES_LEFT]


    if (nMode == ME_INIT)
        if (aEdit[ES_WRAP])
            /* turn off word wrap */
            aEdit[ES_WRAP] := .f.
            return (ME_TOGGLEWRAP)  /* NOTE */
        end

        SetCursor( if(aEdit[ES_INS], SC_INSERT, SC_NORMAL) )

    elseif (nMode == ME_IDLE)
        StatMsg()

    else
        /* keystroke exception */
        if (nMode == ME_UNKEYX)
            aEdit[ES_CHANGED] := .t.
        end

        do case
        case (nKey == EK_QUIT)
            return (K_CTRL_W)
        case (nKey == -5 )       && F6
            return (K_CTRL_W)
        case (nKey == -15)       && SHIFT F6
            return (K_CTRL_W)

        otherwise
        end
    end

return (0)

****
*   PExit()
*

func PExit()
local c, lRet, nCtype

    lRet = .t.
    if ( aEdit[ES_CHANGED] )
        nCtype := SetCursor(SC_NORMAL)
        @ 24,0 SAY '                                                                           '
        Msg("Desea Salir [S/N]                                    ")
        while ( !((c := Upper(Chr(InKey(0)))) $ ("SN" + Chr(K_ESC))) )
        end
        if ( c != "S" )
           Set Key K_F7 To
           lRet := .f.
           r_condensa = .T.
        ELSE
           indice := nfile + 1
        END

        Msg("")

        SetCursor(nCtype)

    end

return (lRet)

****
*   Msg()
*

func Msg(text)
static oldLength := 0

    if (oldLength != 0)
        @ nMaxRow, 0 SAY Replicate(" ", oldLength)
    end

    @ 24, 0 SAY text
    oldLength := Len(text)

return (NIL)

****
*   StatMsg()
*
func StatMsg()
local cLine, cCol, nCtype, nRow, nCol

    cLine := PadR(LTrim(Str(aEdit[ES_ROW])),6,' ')
    cCol  := PadR(LTrim(Str(aEdit[ES_COL])),6,' ')

    nCtype := SetCursor(0)
    nRow := Row()
    nCol := Col()
    @ 23,0  SAY CENTERING("[F6]=Avanza Pantalla   [SHIFT+F6]=Regresa Pantalla   [F7]=Imprime Archivo)")
    @ 24,5  SAY "Consultores en Sistemas   Fila: " + cLine + "Columna: " + cCol + "     Pantalla  "+AllTrim(Str(indice))+"/"+AllTrim(Str(nfile))
    DevPos(nRow, nCol)
    SetCursor(nCtype)

return (NIL)
