 ****************************************************************************
 * Name:      LD_BKUP.prg                                                   *
 *            Richard M. Badish & J.Papadopolo                              *
 * Task:      Backup files to removable media                               *
 *                                                                          *
 * Function:  HNEW()    New disk                                            *
 *            HPROMPT() Text on line 24                                     *
 *            HSORRY()  Popup window                                        *
 *                                                                          *
 * Procedure:                                                               *
 *            HSTAT     Display status                                      *
 *                                                                          *
 * Local:                                                                   *
 *            lrow      display pointer                                     *
 *            lclm      display pointer                                     *
 *            lbyte_tot bytes to be copied                                  *
 *            lbyte_cop bytes copied                                        *
 *            lfile_no  file number (ARRAY pointer)                         *
 *            lfiles    No of files to back up                              *
 *            lsource   Source file *.*                                     *
 *            lname     name of file without extension                      *
 *            linfile   F handle                                            *
 *            loutfile  F handle                                            *
 *            lxx       temporary                                           *
 *            lread     read value and bytes read                           *
 *            lwrite    bytes written                                       *
 *            ldrive    drive to backup to                                  *
 *            ldisk_no  disk number in use                                  *
 *            linc      no of bytes copied each time round the loop         *
 *            lbuffer   text buffer                                         *
 *            lpos      position in input file relative to 0                *
 *            lexit     logical counter                                     *
 *            lbackno   a number given a backup set                         *
 *            ARname[]  array with file names                               *
 *            ARsize[]  array with file sizes                               *
 ****************************************************************************

PRIV lrow,lclm,lbyte_tot,lbyte_cop,lfile_no,linfile,lxx,lread,ldrive,lbackno,;
     ldisk_no,linc,lbuffer,loutfile,lpos,lexit,lwrite,lname,lfiles,lpath,lsource,;
     xcol, xcuantova, xchar, xregistros, xcuadro, xcuantos

******************************************************************************
SET CURSOR OFF
SETCOLOR(Ventana)

@  1,0 SAY ""
@  2,0 SAY "                                            Hora                              "
@  3,0 SAY ""
@  4,0 SAY ""
@  5,0 SAY "Ŀ"
@  6,0 SAY "La Copia se Efectuara                           Copiando Archivos :      "
@  7,0 SAY "Del :                                                                    "
@  8,0 SAY "Al  :          Mes y Ao :                                               "
@  9,0 SAY "Archivos a Copiar  : CIV21&xcodemp..DAT                                         "
@ 10,0 SAY "                                                                         "
@ 11,0 SAY "                                                                         "
@ 12,0 SAY "                                                                         "
@ 13,0 SAY "ٲ"
@ 14,0 SAY " Ŀ Ŀ "
@ 15,0 SAY " Duracion Backup ......               Numero de Diskettes a Utilizar  "
@ 16,0 SAY " Tamao en Bytes ......              5  360 Kb...........            "
@ 17,0 SAY " Ŀ                       1.2 Mb...........            "
@ 18,0 SAY "                    Ŀ                        "
@ 19,0 SAY "                                                          Ŀ "
@ 20,0 SAY "      3  720 Kb...........            "
@ 21,0 SAY "  0      25     50     75     100 %      1.4 Mb...........            "
@ 22,0 SAY "     "
@ 23,0 SAY ""
@ 24,0 SAY "                                                                                "
SETCOLOR(titulos)
@ 2, 2 SAY xempresa
@ 2,50 SAY TIME()
@ 2,61 SAY FECHA(DATE())
@ 2, 2 SAY xempresa

lbackno = SECONDS()    && A serial number for the backup set
SETCOLOR(DATOS)
r_mas = .T.
******************************************************************************
lbcop = 0
DO WHIL r_mas
   lfiles7 = 0
   opc     = 'N'
   x_emp   = xcodemp
   lpath   = "\"+CURDIR()+"\"
   lpath   = lpath+SPAC(30-LEN(lpath))
   ldrive  = "A"
   STORE SUBSTR(DTOC(date()),4,2)+ SUBSTR(DTOC(date()),9,2) TO l_mes
   HPROMPT("Directorio donde se encuentran los archivos a Copiar   [ESC]=Finaliza")
   @  7, 9 GET lpath
   @  8, 9 GET ldrive  PICTURE "@!"
   @  8,30 GET l_mes   PICTURE "9999"
   SET CURSOR ON
   READ
   SET CURSOR OFF
   lpath    = TRIM(lpath)
   lnamemem = 'back&l_mes'
   per_back = 'HV&l_mes&xcodemp'
   xcol     = 7

   IF LASTKEY() = 27
      F_ARCHIS(.T.)
      r_mas = .F.
      RETURN
   ENDIF

   IF LASTKEY()<>27
      F_ARCHIS(.F.)
   ENDIF

   lsource = 'CIV2?&xcodemp..CES'
   lsource  = TRIM(lsource)

   IF ! ldrive $ "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
      HSORRY(" Drive que ingreso No disponible")
   ELSE
      lfiles = ADIR(lpath+lsource)      && See how many .dbt & .dbf files (.dat)
      IF lfiles = 0
         HSORRY(" Archivo no Existe ")
      ELSE
         EXIT
      ENDIF
   ENDIF
   IF LASTKEY() = 27
      F_ARCHIS(.T.)
      r_mas = .F.
      RETURN
   ENDIF

ENDDO

IF LASTKEY()<>27

 ****************** Read file names into Array and count bytes ****************
 lbyte_tot = 0                       && bytes to be backed up
 lbyte_cop = 0                       && bytes backed up so far

 PRIV ARname[lfiles]
 PRIV ARsize[lfiles]
 ADIR(lpath+lsource,ARname,ARsize) && read names to ARname[], sizes to ARsize
 FOR lxx = 1 TO lfiles
    lbyte_tot  = lbyte_tot + ARsize[lxx]
    xregistros = lbyte_tot
 NEXT
 ******************************************************************************

 DO HSTAT
 ******************* Display number of disks needed **************************
 lxx=lbyte_tot/360000
 @ 16,65 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/1200000
 @ 17,65 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/720000
 @ 20,65 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/1400000
 @ 21,65 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 *****************************************************************************
 IF LASTKEY()=27
    F_ARCHIS(.T.)
    r_mas = .F.
    RETURN
 ENDIF

 linc     = 1024
 lrow     = 7
 lclm     = 46
 ldisk_no = 1

 IF HNEW()

    FOR lfile_no = 1 TO lfiles

       lbuffer  = SPAC(linc)
       lname    = ARname[lfile_no]
       linfile  = FOPEN(lpath+lname)            && Open the source file
       lexten   = SUBSTR(lname,4,2)
       lname1   = 'IV' + xcodemp + l_mes + '.' + lexten
       loutfile = FCREATE(ldrive+":"+lname1)    && Create the target file
       lpos     = 0
       lexit    = .F.

       SETCOLOR(Datos)
       @ 19,xcol SAY ''
       @ lrow,lclm SAY lname1
       SET COLO TO *w/b
       @ lrow,lclm+12 SAY " *"
       SETCOLOR(Datos)

       DO WHILE .T.
          lread     = FREAD(linfile,@lbuffer,linc)    && read buffer
          lwrite    = FWRITE(loutfile,lbuffer,lread)  && write buffer
          lpos      = lpos+lwrite
          lbyte_cop = lbyte_cop+lwrite
          lbcop     = lbcop + lwrite
          DO HSTAT
          IF lwrite < lread       && THE WHOLE FILE DID NOT FIT
             FSEEK(linfile,lpos)       && position pointer where text ended
             FCLOSE(loutfile)          && close the outfile
             ldisk_no = ldisk_no+1            && increment disk number
             IF HNEW()
                loutfile = FCREATE(ldrive+":"+lname1)  && continue on a new disk
             ELSE
                lexit = .T.  && user decided to Quit
                EXIT
             ENDIF
          ELSE
             IF lread = 0    && File has been successfully copied
                SETCOLOR(Datos)
                @ 19,xcol SAY ''
                xcol = xcol+15
                @ lrow,lclm+12 SAY " "
                lclm=IF(lrow<>12,lclm,IF(lclm=62,46,62))
                lrow=IF(lrow<>12,lrow+1,7)
                EXIT
             ENDIF
          ENDIF
       ENDDO

       FCLOSE(linfile)
       FCLOSE(loutfile)

       IF lexit
          @ lrow,lclm+12 SAY "  "
          EXIT
       ENDIF

    NEXT

    IF ! lexit
       F_ARCHIS(.T.)
       SETCOLOR(Datos)
       @ 19,xcol SAY ''
       xcol = xcol+15
       HSORRY("COPIA COMPLETADA")
    ENDIF
  ENDIF

ENDIF

SET CURSOR ON
CLEAR
RETU

******************************************************************************
******************************************************************************
