
 ****************************************************************************
 * Name:      Per_Rest.prg                                                  *
 *            Richard M. Badish & J.Papadopolo                              *
 * Task:      Restore files from removable media                            *
 *                                                                          *
 * Function:  HISREST()    New disk                                           *
 *            HPROMPT()  Text on line 24                                    *
 *            HSORRY()   Popup window                                       *
 * Procedure:                                                               *
 *            HSTAT     Display copying progress                            *                                  *
 * Local:                                                                   *
 *            lrow      display pointer                                     *
 *            lclm      display pointer                                     *
 *            lbyte_tot bytes to be copied                                  *
 *            lbyte_cop bytes copied                                        *
 *            lfile_no  file number (ARRAY pointer)                         *
 *            lname     name of file without extension                      *
 *            lback     name of file with .bak extension                    *
 *            linfile   F handle                                            *
 *            loutfile  F handle                                            *
 *            lxx       temporary                                           *
 *            lread     read value and bytes read                           *
 *            lwrite    bytes written                                       *
 *            ldrive    drive to backup to                                  *
 *            ldisk_no  disk number in use                                  *
 *            linc      no of bytes copied each time round the loop         *
 *            lbuffer   text buffer                                         *
 *            lpos      position in input file relative to 0                *
 *            lexit     logical counter                                     *
 *            lbackno   a number given a backup set                         *
 *            ARcopy[]  array with file names of each disk                  *
 ****************************************************************************

PRIV lrow,lclm,lbyte_tot,lbyte_cop,lfile_no,linfile,lxx,lread,ldrive,lbackno,;
     ldisk_no,linc,lbuffer,loutfile,lpos,lexit,lwrite,lname,lback,lscreen

PRIV PX_disk,PX_number,PX_byte, PX_otro, xcol, xcuantova, xchar, xregistros, xcuadro, xcuantos
lpos     = 0

******************************************************************************
SET CURSOR OFF
@  1,0 SAY ""
@  2,0 SAY "                                            Hora                              "
@  3,0 SAY ""
@  4,0 SAY ""
@  5,0 SAY "Ŀ"
@  6,0 SAY "La Restauracion se Efectuara                  Restaurando Archivos :     "
@  7,0 SAY "Del :          Mes y Ao :                                               "
@  8,0 SAY "Al  :                                                                    "
@  9,0 SAY "                                                                         "
@ 10,0 SAY "                                                                         "
@ 11,0 SAY "                                                                         "
@ 12,0 SAY "                                                                         "
@ 13,0 SAY "ٲ"
@ 14,0 SAY " Ŀ Ŀ "
@ 15,0 SAY " Duracion Restauracion.               Numero de Diskettes a Utilizar  "
@ 16,0 SAY " Tamao en Bytes ......              5  360 Kb...........            "
@ 17,0 SAY " Ŀ                       1.2 Mb...........            "
@ 18,0 SAY "                    Ŀ                        "
@ 19,0 SAY "                                                          Ŀ "
@ 20,0 SAY "      3  720 Kb...........            "
@ 21,0 SAY "  0      25     50     75     100 %      1.4 Mb...........            "
@ 22,0 SAY "     "
@ 23,0 SAY ""
@ 24,0 SAY "                                                                                "
SETCOLOR(titulos)
@ 2, 2 SAY xempresa
@ 2,50 SAY TIME()
@ 2,61 SAY FECHA(DATE())
@ 2, 2 SAY xempresa

lbackno = SECONDS()    && A serial number for the backup set

tone(900,1)
tone(900,1)
r_pasa     = .T.
lname1     = ""
r_mas      = .T.
l_contador = 0
xotro      = zmov_omes
xcol       = 7
cl1        = 1
cl2        = 1
cl3        = 1
cl4        = 1
cl5        = 1
cl6        = 1
ldisk_no   = 1

*******************************************************************************
DO WHIL r_mas
   lpath   = "\"+CURDIR()+"\"
   lpath   = lpath+SPAC(30-LEN(lpath))
   ldrive  = "A"
   STORE SUBSTR(DTOC(date()),4,2)+ SUBSTR(DTOC(date()),9,2) TO xmes

   HPROMPT("Origen : Drive donde se encuentran los archivos    [ESC]=Finaliza")
   @ 7, 9 GET ldrive PICT "@A !"
   @ 7,30 GET xmes PICTURE "9999"
   @ 8, 9 GET lpath
   SET CURSOR ON
   READ

   per_back = 'HV&xmes&xcodemp'


   IF LASTKEY()=27
      r_mas = .F.
      RETURN
   ENDIF
   SET CURSOR OFF
   lpath    = TRIM(lpath)

   IF ! ldrive $"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
     HSORRY("Drive que Ingreso no Disponible")
   ELSE
     lxx = FCREATE(lpath+"tmp")
     IF lxx = -1
	HSORRY("Destino : Drive o Directorio no Existe ")
     ELSE
	FCLOSE(lxx)
        IF ldrive $ "AB"
	   *ERASE &lpath.tmp
        ENDIF
	EXIT
     ENDIF
   ENDIF
ENDDO

IF LASTKEY()<>27

 lrow      = 7
 lclm      = 46
 lbackno   = 0
 linc      = 1024
 lback     = ""
 lname     = ""
 lbyte_tot = 0
 lbyte_cop = 0
 xbyte_cop = 0

 DO WHILE .T.
    lscreen  = SAVESCREEN(21,0,23,79)
    IF ldrive $ "AB"
       SAVE SCREEN TO xrestor7
       lxx = "INGRESE  Disco No ["+STR(ldisk_no,2)+"] en drive ["+ldrive+"]"
       @ 13,(76-LEN(lxx))/2,15,(82+LEN(lxx))/2 BOX ""
       @ 14,(80-LEN(lxx))/2 SAY lxx
       HPROMPT("Favor Espere :   Presione [BARRA] para Continuar    [ESC]=Finaliza")
       l_mas = ' '
       @ 14,3 GET l_mas
       READ
       RESTORE SCREEN FROM xrestor7
    ENDIF

    HPROMPT("Favor Espere :   Presione [BARRA] para Continuar    [ESC]=Finaliza")
    IF INKEY(0)=27     && WAIT
       RESTSCREEN(21,0,23,79,lscreen)
       EXIT            && --------> [ESC]
    ELSE
       HPROMPT("Copia:                    ACCESANDO EL DISCO                 [ESC]=Finaliza")
       IF ldrive $ "CDEFGHIJKLMNOPQRSTUVWXYZ"
          IF FILE(ldrive+":&per_back..mem")
	     REST FROM &ldrive.:&per_back..mem ADDI
             lbyte_tot = PX_byte     && bytes to copy
             lbackno   = PX_number
             xotro     = PX_otro
             xregistros = lbyte_tot
             DO HSTAT
          ELSE
             TONE (900,2)
             TONE (300,3)
             HSORRY("No Existe Copia Para este Periodo")
             EXIT
	  ENDIF
          IF ! rstr("CIV21&xcodemp..DAT","HV&xcodemp&xmes..21",ldrive)
             HSORRY("'CIV21&xcodemp..DAT' NO FUE RESTAURADO !!")
          ENDIF
          IF INKEY(.1)=27 .OR. LASTKEY()=27
             RETURN
          ENDIF
          SETCOLOR(datos)
          @ 19,xcol SAY ''
          HSORRY("RESTAURACION COMPLETADA")
          xcol = xcol+15
          INKEY(10)
          EXIT
       ELSE

          IF FILE(ldrive+":&per_back..mem")
	     RESTORE FROM &ldrive.:&per_back..mem ADDI
	     IF PX_disk = ldisk_no
	        IF (PX_number=lbackno).OR.ldisk_no=1  && ALL CONTROLS PASSED
		   IF ldisk_no = 1
		      lbyte_tot = PX_byte     && bytes to copy
		      lbackno   = PX_number
                      xbytecop  = PX_cop
                      xotro     = PX_otro
		      DO HSTAT
	           ENDIF

		   PRIV ARcopy[ADIR(ldrive+":*.*")]
		   PRIV ARsize[ADIR(ldrive+":*.*")]
		   ADIR(ldrive+":*.*",ARcopy,ARsize)
		   RESTSCREEN(21,0,23,79,lscreen)
		   IF HISREST()   &&--------> DO DISK READ ROUTINE
		      EXIT
		   ENDIF
		   ldisk_no = ldisk_no+1            && increment disk number
	        ELSE
		   HSORRY("Este diskette no pertenece a esta Copia ")
	        ENDIF
	     ELSE
	        HSORRY("Este no es numero correcto de disco")
	     ENDIF
          ELSE
             HSORRY("No hay diskette en el drive o no es la copia correcta")
          ENDIF
       ENDIF
    ENDIF
 ENDDO

 IF lbyte_cop <> lbyte_tot   && ESCAPED while restore not complete
    IF ldrive $ "AB"
       RENAME &lpath.&lback TO &lpath.&lname
    ENDIF
    lbyte_cop = lbyte_cop-lpos
    DO HSTAT
    @ lrow,lclm+12 SAY " -"
 ENDIF

ENDI

SET CURS ON
CLEAR
RETU

******************************************************************************
******************************************************************************
FUNC HISREST      && restore files from one disk

lexit      = .F.
r_si       = .T.
r_primera  = .T.
FOR lfile_no = 2 TO LEN(ARcopy)   && (skips 1 -> lnamemem.mem)

    * VERIFICA SI HAY UN ARCHIVO MAS O DIFERENTE DE LA COPIA
    IF ldisk_no > 1 .AND. r_primera
       l_cuantos = lfile_no
       FOR lfile_no2 = 1 TO LEN(ARcopy)   && (skips 1 -> lnamemem.mem)
           IF lfile_no2 = 1
              IF ARcopy[lfile_no2] = "&per_back..MEM"
                 EXIT
              ENDIF
           ENDIF
           IF lname = ARcopy[lfile_no2]                     && APPEND TO FILE
              si_hay = .T.
              l_cuantos = lfile_no2
              EXIT
           ENDIF
       NEXT
       lfile_no  = l_cuantos
       r_primera = .F.
    ENDIF

    IF lname = ARcopy[lfile_no]                     && APPEND TO FILE
       IF lname = "IV&xcodemp&xmes..21"
          lname1 = "CIV21&xcodemp..DAT"
       ELSE
       ENDIF
       loutfile = FOPEN(lpath+lname1,2)
       FSEEK(loutfile,0,2)   && move to end of file
    ELSE                                            && MAKE NEW FILE
       r_si  = .T.
       IF lbyte_cop > 0
          SETCOLOR(datos)
          @ 19,xcol SAY ''
          xcol = xcol+15
	  @ lrow,lclm+12 SAY " "
          lclm=IF(lrow<>12,lclm,IF(lclm=62,46,62))
          lrow=IF(lrow<>12,lrow+1,7)
       ENDI
       IF ldrive $ "AB"
          *ERASE &lpath.&lback
       ENDIF
       lname = ARcopy[lfile_no]
       IF lname = "IV&xcodemp&xmes..21"
          lname1 = "CIV21&xcodemp..DAT"
          IF cl1 = 1
             l_contador = l_contador + 1
             cl1 = cl1 + 1
          ENDIF
       ELSE
          r_si = .F.
          IF l_contador = 1
             lexit      =  .T.
             lbyte_cop  = lbyte_tot
             EXIT
          ELSE
            *r_pasa = .F.
          ENDIF
       ENDIF
       IF r_si
          IF FILE(lpath+lname)
	     lback = LEFT(lname,LEN(lname)-4)+".bak"
	     RENAME &lpath.&lname TO &lpath.&lback
          ENDIF
          loutfile = FCREATE(lpath+lname1)             && Create the target file
          SETCOLOR(datos)
          @ 19,xcol SAY ''
          @ lrow,lclm SAY lname
          SET COLO TO *w/b
          @ lrow,lclm+12 SAY " *"
          SETCOLOR(Datos)
       ENDIF
    ENDI
    IF r_si
       linfile  = FOPEN(ldrive+":"+lname)      && Open the source file
       lbuffer  = SPAC(linc)
       lpos     = 0

       DO WHIL r_pasa
          lread     = FREAD(linfile,@lbuffer,linc)
          lwrite    = FWRITE(loutfile,lbuffer,lread)
          lpos      = lpos+lwrite
          lbyte_cop = lbyte_cop + lwrite
          DO HSTAT
          IF lwrite < lread       && SOMETHING WENT WRONG
	     HSORRY("Error de DOS al accesar el disco "+STR(FERROR(),3))
	     lexit = .T.
	     EXIT
          ELSE
	     IF lread = 0    && File has been successfully copied
                EXIT
	     ENDIF
          ENDIF
       ENDDO

       FCLOSE(linfile)
       FCLOSE(loutfile)

       IF lexit
          EXIT
       ENDIF
    ENDIF

NEXT

IF (lbyte_cop = lbyte_tot)
   IF xcol < 37
      SETCOLOR(datos)
      @ 19,xcol SAY ''
      xcol = xcol + 15
      * @ lrow,lclm+12 SAY " "
   ENDIF
   HSORRY("RESTAURACION COMPLETADA")
   lexit=.T.
ENDI

RETU lexit
