 ****************************************************************************
 * Name:      LD_BKUP.prg                                                   *
 *            Richard M. Badish & J.Papadopolo                              *
 * Task:      Backup files to removable media                               *
 *                                                                          *
 * Function:  HNEW()    New disk                                            *
 *            HPROMPT() Text on line 24                                     *
 *            HSORRY()  Popup window                                        *
 *                                                                          *
 * Procedure:                                                               *
 *            HSTAT     Display status                                      *
 *                                                                          *
 * Local:                                                                   *
 *            lrow      display pointer                                     *
 *            lclm      display pointer                                     *
 *            lbyte_tot bytes to be copied                                  *
 *            lbyte_cop bytes copied                                        *
 *            lfile_no  file number (ARRAY pointer)                         *
 *            lfiles    No of files to back up                              *
 *            lsource   Source file *.*                                     *
 *            lname     name of file without extension                      *
 *            linfile   F handle                                            *
 *            loutfile  F handle                                            *
 *            lxx       temporary                                           *
 *            lread     read value and bytes read                           *
 *            lwrite    bytes written                                       *
 *            ldrive    drive to backup to                                  *
 *            ldisk_no  disk number in use                                  *
 *            linc      no of bytes copied each time round the loop         *
 *            lbuffer   text buffer                                         *
 *            lpos      position in input file relative to 0                *
 *            lexit     logical counter                                     *
 *            lbackno   a number given a backup set                         *
 *            ARname[]  array with file names                               *
 *            ARsize[]  array with file sizes                               *
 ****************************************************************************

PRIV lrow,lclm,lbyte_tot,lbyte_cop,lfile_no,linfile,lxx,lread,ldrive,lbackno,;
     ldisk_no,linc,lbuffer,loutfile,lpos,lexit,lwrite,lname,lfiles,lpath,lsource,;
     xcol, xcuantova, xchar, xregistros, xcuadro, xcuantos

******************************************************************************
SET CURSOR OFF
SETCOLOR(Ventana)

@  1,0 SAY ""
@  2,0 SAY "                                            Hora                              "
@  3,0 SAY ""
@  4,0 SAY ""
@  5,0 SAY "Ŀ"
@  6,0 SAY "La Copia se Efectuara                           Copiando Archivos :      "
@  7,0 SAY "Del :                                                                    "
@  8,0 SAY "Al  :          Mes y Ao :                                               "
@  9,0 SAY "Archivos a Copiar  : CIV01&xcodemp..DAT                                         "
@ 10,0 SAY "                                                                         "
@ 11,0 SAY "                                                                         "
@ 12,0 SAY "                                                                         "
@ 13,0 SAY "ٲ"
@ 14,0 SAY " Ŀ Ŀ "
@ 15,0 SAY " Duracion Backup ......               Numero de Diskettes a Utilizar  "
@ 16,0 SAY " Tamao en Bytes ......              5  360 Kb...........            "
@ 17,0 SAY " Ŀ                       1.2 Mb...........            "
@ 18,0 SAY "                    Ŀ                        "
@ 19,0 SAY "                                                          Ŀ "
@ 20,0 SAY "      3  720 Kb...........            "
@ 21,0 SAY "  0      25     50     75     100 %      1.4 Mb...........            "
@ 22,0 SAY "     "
@ 23,0 SAY ""
@ 24,0 SAY "                                                                                "
SETCOLOR(titulos)
@ 2, 2 SAY xempresa
@ 2,50 SAY TIME()
@ 2,61 SAY FECHA(DATE())
@ 2, 2 SAY xempresa

lbackno = SECONDS()    && A serial number for the backup set
SETCOLOR(DATOS)
r_mas = .T.
******************************************************************************
lbcop = 0
DO WHIL r_mas
   lfiles7 = 0
   opc     = 'N'
   x_emp   = xcodemp
   lpath   = "\"+CURDIR()+"\"
   lpath   = lpath+SPAC(30-LEN(lpath))
   ldrive  = "A"
   STORE SUBSTR(DTOC(date()),4,2)+ SUBSTR(DTOC(date()),9,2) TO l_mes
   HPROMPT("Directorio donde se encuentran los archivos a Copiar   [ESC]=Finaliza")
   @  7, 9 GET lpath
   @  8, 9 GET ldrive  PICTURE "@!"
   @  8,30 GET l_mes   PICTURE "9999"
   SET CURSOR ON
   READ
   SET CURSOR OFF
   lpath    = TRIM(lpath)
   lnamemem = 'back&l_mes'
   per_back = 'IV&l_mes&xcodemp'
   xcol     = 7

   IF LASTKEY() = 27
      F_ARCHIVOS(.T.)
      r_mas = .F.
      RETURN
   ENDIF

   IF LASTKEY()<>27
      F_ARCHIVOS(.F.)
   ENDIF

   lsource = 'CIV0?&xcodemp..CES'
   lsource  = TRIM(lsource)

   IF ! ldrive $ "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
      HSORRY(" Drive que ingreso No disponible")
   ELSE
      lfiles = ADIR(lpath+lsource)      && See how many .dbt & .dbf files (.dat)
      IF lfiles = 0
         HSORRY(" Archivo no Existe ")
      ELSE
         EXIT
      ENDIF
   ENDIF
   IF LASTKEY() = 27
      F_ARCHIVOS(.T.)
      r_mas = .F.
      RETURN
   ENDIF

ENDDO

IF LASTKEY()<>27

 ****************** Read file names into Array and count bytes ****************
 lbyte_tot = 0                       && bytes to be backed up
 lbyte_cop = 0                       && bytes backed up so far

 PRIV ARname[lfiles]
 PRIV ARsize[lfiles]
 ADIR(lpath+lsource,ARname,ARsize) && read names to ARname[], sizes to ARsize
 FOR lxx = 1 TO lfiles
    lbyte_tot  = lbyte_tot + ARsize[lxx]
    xregistros = lbyte_tot
 NEXT
 ******************************************************************************

 DO HSTAT
 ******************* Display number of disks needed **************************
 lxx=lbyte_tot/360000
 @ 16,65 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/1200000
 @ 17,65 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/720000
 @ 20,65 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/1400000
 @ 21,65 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 *****************************************************************************
 IF LASTKEY()=27
    F_ARCHIVOS(.T.)
    r_mas = .F.
    RETURN
 ENDIF

 linc     = 1024
 lrow     = 7
 lclm     = 46
 ldisk_no = 1

 IF HNEW()

    FOR lfile_no = 1 TO lfiles

       lbuffer  = SPAC(linc)
       lname    = ARname[lfile_no]
       linfile  = FOPEN(lpath+lname)            && Open the source file
       lexten   = SUBSTR(lname,4,2)
       lname1   = 'IV' + xcodemp + l_mes + '.' + lexten
       loutfile = FCREATE(ldrive+":"+lname1)    && Create the target file
       lpos     = 0
       lexit    = .F.


       SETCOLOR(datos)
       @ 19,xcol SAY ''
       @ lrow,lclm SAY lname1
       SET COLO TO *w/b
       @ lrow,lclm+12 SAY " *"
       SETCOLOR(datos)

       DO WHILE .T.
          lread     = FREAD(linfile,@lbuffer,linc)    && read buffer
          lwrite    = FWRITE(loutfile,lbuffer,lread)  && write buffer
          lpos      = lpos+lwrite
          lbyte_cop = lbyte_cop+lwrite
          lbcop     = lbcop + lwrite
          DO HSTAT
          IF lwrite < lread       && THE WHOLE FILE DID NOT FIT
             FSEEK(linfile,lpos)       && position pointer where text ended
             FCLOSE(loutfile)          && close the outfile
             ldisk_no = ldisk_no+1            && increment disk number
             IF HNEW()
                loutfile = FCREATE(ldrive+":"+lname1)  && continue on a new disk
             ELSE
                lexit = .T.  && user decided to Quit
                EXIT
             ENDIF
          ELSE
             IF lread = 0    && File has been successfully copied
                SETCOLOR(Datos)
                @ 19,xcol SAY ''
                xcol = xcol+15
                @ lrow,lclm+12 SAY " "
                lclm=IF(lrow<>12,lclm,IF(lclm=62,46,62))
                lrow=IF(lrow<>12,lrow+1,7)
                EXIT
             ENDIF
          ENDIF
       ENDDO

       FCLOSE(linfile)
       FCLOSE(loutfile)

       IF lexit
          @ lrow,lclm+12 SAY "  "
          EXIT
       ENDIF

    NEXT

    IF ! lexit
       F_ARCHIVOS(.T.)
       SETCOLOR(datos)
       @ 19,xcol SAY ''
       xcol = xcol+15
       HSORRY("COPIA COMPLETADA")
    ENDIF
  ENDIF

ENDIF

SET CURSOR ON
CLEAR
RETU

******************************************************************************
******************************************************************************
FUNC HNEW           && prompt for a new disk
PRIV lscreen,PX_disk,PX_number,PXbyte,ltemp,lfile

lscreen = SAVESCREEN(21,0,23,79)
r_mas  = .T.
DO WHIL  r_mas
   IF ldrive $ "AB"
      SAVE SCREEN TO xcopia7
      SETCOLOR(Ventana)
      lxx = "INGRESE Disco No ["+STR(ldisk_no,2)+"] en el Drive ["+ldrive+"]"
      @ 24,0 SAY CENTERING("Presione [ENTER] Para Continuar")
      SETCOLOR(Datos)
      @ 13,(76-LEN(lxx))/2,15,(82+LEN(lxx))/2 BOX ""
      @ 14,(80-LEN(lxx))/2 SAY lxx
      ACCEPT TO xxxx
      RESTORE SCREEN FROM xcopia7
   ENDIF
   HPROMPT("Favor Espere :   Presione [BARRA] para Continuar    [ESC]=Finaliza")
   * HPROMPT("     Presione Barra Para Continuar           [ESC]=Finaliza")

   IF FILE(ldrive+":&per_back..mem")
      REST FROM &ldrive.:&per_back..mem ADDI
      xmes = PX_mes
      IF xmes = l_mes
        TONE(400,3)
        TONE(1000,4)
        HPROMPT("En este Disco Existe Copia De Este Mes Sobre Graba Si o No")
        @ 24,79 GET opc  PICTURE "@!" VALID opc $ 'SN'
        READ
        HPROMPT("     Presione [Barra] Para Continuar           [ESC]=Finaliza")
        IF opc = 'S'
           IF ldrive = 'A'
              DELETE FILE A:'IV'+xcodemp+l_mes..*
           ELSEIF ldrive = 'B'
              DELETE FILE B:'IV'+xcodemp+l_mes..*
           ENDIF
        ENDIF
      ELSE
         IF ldrive $ "AB"
            TONE(400,3)
            TONE(1000,4)
            INKEY(2)
            HPROMPT("Precaucion: En este Disco Existe Copia De OTRO MES, Prosigue Si o No")
            @ 24,79 GET opc  PICTURE "@!" VALID opc $ 'SN'
            READ
            HPROMPT("     Presione [Barra] Para Continuar           [ESC]=Finaliza")
         ELSE
            opc = 'S'
         ENDIF
      ENDIF
      lfiles7 = 1
   ELSE
      IF ldrive $ 'AB'
         lfiles7 = ADIR(ldrive+":*.*")      && See how many .dbt & .dbf files (.dat)
         IF lfiles7 <> 0
            TONE(400,3)
            TONE(1000,4)
            INKEY(2)
            HPROMPT("Precaucion: Existe informacion Dentro de este Disco, Prosigue Si o No")
            @ 24,79 GET opc  PICTURE "@!" VALID opc $ 'SN'
            READ
            HPROMPT("     Presione [Barra] Para Continuar           [ESC]=Finaliza")
         ENDIF
      ENDIF
   ENDIF
   IF opc = "N"  .AND. lfiles7 <> 0
      F_ARCHIVOS(.T.)
      CLOSE DATA
      RETURN .F.
   ENDIF

   IF INKEY(0)=27      && WAIT
      RESTSCREEN(21,0,23,79,lscreen)
      RETU .F.        && --------> [ESC]
   ELSE
      HPROMPT("                    ACCESANDO EL DISCO                        [ESC]=Finaliza")
      lxx = FCREATE(ldrive+":tmp")
      IF lxx<>-1       && disk is write ready
         ERASE &ldrive.:tmp
         IF FILE(ldrive+":&per_back..mem")
            REST FROM &ldrive.:&per_back..mem ADDI
            IF PX_mes = l_mes
               x_siga = .T.
            ELSE
               x_siga = .F.
            ENDIF
         ELSE
            PX_disk   = ldisk_no
            PX_number = 0
            x_siga    = .T.
         ENDIF
         IF (PX_disk<ldisk_no.AND.PX_number<>lbackno).OR.PX_disk>=ldisk_no .AND. x_siga && All test passed
            ******* deleting all files on target ****************
            ltemp = ADIR(ldrive+":&lsource")  && count files meeting wildcard
            PRIV ARtemp[ltemp]
            PRIV ARsize[ltemp]
            *ADIR(ldrive+":&lsource",ARtemp,ltemp) && read names to ARtemp[]
            ADIR(ldrive+":CIV??&xcodemp.CES",ARtemp,ltemp) && read names to ARtemp[]
            FOR lxx = 1 TO ltemp
              lfile = ARtemp[lxx]
              ERASE &ldrive.:&lfile
            NEXT

            *****************************************************
            PX_mes    = l_mes
            PX_disk   = ldisk_no
            PX_number = lbackno
            PX_byte   = lbyte_tot
            PX_cop    = lbcop
            PX_otro   = zmov_omes
            SAVE TO &ldrive.:&per_back..mem  ALL LIKE PX_*
            RESTSCREEN(21,0,23,79,lscreen)
            RETU .T.
         ELSE
            lxx = " Este Disco ya ha Sido Utilizado "
            @ 17,(76-LEN(lxx))/2,19,(82+LEN(lxx))/2 BOX ""
            @ 18,(80-LEN(lxx))/2 SAY lxx
            HSORRY("Por Seguridad NO es Recomendable Efectuar dos copias al mismo disco")
         ENDIF
      ELSE
         HSORRY(" No hay disco en el drive o esta Protegido / Disco no Formateado")
      ENDIF
   ENDIF
ENDDO
******************************************************************************
******************************************************************************
PROC HSTAT       && progress status
PRIV ltime

ltime = (lbyte_tot-lbyte_cop)/2900    && I found speed to be approx 2900 b/sec
@ 15,28 SAY SUBS(STR(INT(ltime/3600%24)+10^2,2+1),2)+":"+;   && Hours
            SUBS(STR(INT(ltime/60%60)+10^2,2+1),2)+":"+;     && Minutes
            SUBS(STR(INT(ltime%60)+10^2,2+1),2)              && Seconds

@ 16,28 SAY TRAN(lbyte_tot-lbyte_cop,"999,999,999")

*@ 12,63 SAY TRAN(lbyte_cop,"999,999,999")
IF lbyte_tot = 0
   lbyte_tot = 1
ENDIF
*@ 13,69 SAY TRAN(ROUND(lbyte_cop/lbyte_tot*100,0),"999")

RETU
******************************************************************************
******************************************************************************
FUNC HSORRY
PARA lstring
PRIV lscreen,lxx

 ****************************************************************************
 * Syntax:   HSORRY(<expC>)                                                 *
 * Argument: <expC> is string to be shown on screen.                        *
 * Return:   .T.                                                            *
 * Usage:    Used to display a message when the user has made a misstake.   *
 * Note:     The message is placed in a box, and is allways displayed on    *
 *           line 21.                                                       *
 * Example:  HSORRY("Sorry, The name is not valid")                         *
 ****************************************************************************

 lscreen = SAVESCREEN(20,0,22,79)
 TONE(900,1)
 TONE(900,1)
 TONE(900,1)
 TONE(900,2)
 SETCOLOR(Ventana)
 @ 13,(76-LEN(lstring))/2,15,(82+LEN(lstring))/2 BOX ""
 @ 14,(80-LEN(lstring))/2-1 SAY " "+lstring+" "
 SETCOLOR(datos)
 HPROMPT("                 Presione Cualquier tecla para continuar")
 INKEY(0)
 RESTSCREEN(20,0,22,79,lscreen)

RETU .T.



******************************************************************************
******************************************************************************
FUNC HPROMPT
PARA lstring

 ****************************************************************************
 * Syntax:   HPROMPT(<expC>)                                                *
 * Argument: <expC> is the text to be displayed on line 24 in inverse.      *
 * Return:   .T.                                                            *
 * Usage:    To display a prompt line corresponding to current action.      *
 * Note:                                                                    *
 * Example:  HPROMPT("text on line 24")                                     *
 ****************************************************************************

 SETCOLOR(Barra)
 @ 24,1 SAY lstring+SPAC(78-LEN(lstring))
 SETCOLOR(Datos)
RETU .T.

